#! /bin/sh

currentPath=`pwd`
path=$currentPath/`dirname $0`

# cleaning project
rm -fr build
rm -fr src/generated
mkdir build

cd src

java -classpath ../modgen.jar generator.Main -config $NOMAD_MODULE_CONFIG

cd $path

# the sequence of commands to execute (the order is important)
libtoolize --force
aclocal -I config -I m4 --install
autoconf
automake --gnu --add-missing


export CXXFLAGS="$CXXFLAGS -Wall -Wconversion -O2 -g -pthread"

cd build

if [ -d "/usr/local/src/boost" ]
then
# SUSE
../configure --prefix=$NOMAD_HOME/mod --with-boost="/usr/local/src/boost" LIBS=-lboost_system
else
../configure --prefix=$NOMAD_HOME/mod
fi

