/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

/* Generated by Together */

#ifndef REALCFDDRIVER_H
#define REALCFDDRIVER_H

#include "CfdState.h"

namespace cfd {

/*!
 * \class RealCfdDriver
 * \brief Real implementation class for the Cfd device driver
 *
 * This class is a real implementation of Cfd device driver.
 */
class RealCfdDriver: public CfdState {

public:

	/*!
	 * \brief Constructor
	 * \param[in] owner The device driver main class link
	 */
	RealCfdDriver(CfdDriver* owner);

	/*!
	 * Destructor.
	 */
	virtual ~RealCfdDriver();

	/*!
	 * \brief Init command implementation
	 */
	virtual void init();

	/*!
	 * \brief Write Param command implementation
	 */
	virtual void writeParam();

	/*!
	 * \brief Read Infos command implementation
	 */
	virtual void readInfos();

private:

//	/*
//	 * used to calculate the bit_shift in the trpezoidal algorithm (energy)
//	 */
//	int32 pow2roundup(int32 x);

};

}

#endif //REALCFDDRIVER_H
